package marketReseller

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ResellerMerchantModel = (*customResellerMerchantModel)(nil)

type (
	// ResellerMerchantModel is an interface to be customized, add more methods here,
	// and implement the added methods in customResellerMerchantModel.
	ResellerMerchantModel interface {
		resellerMerchantModel
	}

	customResellerMerchantModel struct {
		*defaultResellerMerchantModel
	}
)

// NewResellerMerchantModel returns a model for the database table.
func NewResellerMerchantModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) ResellerMerchantModel {
	return &customResellerMerchantModel{
		defaultResellerMerchantModel: newResellerMerchantModel(conn, c, opts...),
	}
}
